/*
  RCTractor.h - Library for controlling RC Tractors.
  Created by Oisin O'Conchubhair, September 20, 2015.
  Released into the public domain.
*/
#ifndef RCTractorGuy_Excavator_h
#define RCTractorGuy_Excavator_h

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

#include <Servo.h>


class RCExcavator
{
  public:
    RCExcavator();
    void Bucket_Setup(int Mode, int Bucket_PWM, int Bucket_Dir_1, int Bucket_Dir_2, int Bucket_Feedback);
    void Extend_Setup(int Mode, int Extend_PWM, int Extend_Dir_1, int Extend_Dir_2, int Extend_Feedback);
    void Raise_Setup(int Mode, int Raise_PWM, int Raise_Dir_1, int Raise_Dir_2, int Raise_Feedback);
    void Slew_Setup(int Mode, int Slew_PWM, int Slew_Dir_1, int Slew_Dir_2);
    void Track_Setup(int Mode, int Left_Track_PWM, int Left_Track_Dir_1, int Left_Track_Dir_2, int Right_Track_PWM, int Right_Track_Dir_1, int Right_Track_Dir_2);
    void Control(int Bucket_Val,int Extend_Val,int Raise_Val,int Slew_Val,int Left_Track_Val, int Right_Track_Val);
    void Lights(int Light_Val);
    void Sleep(int wake);
    void Timer();
	long ReadVcc();

  private:
	Servo _Bucket_Servo;
	Servo _Extend_Servo;
	Servo _Raise_Servo;
	Servo _Slew_Servo;
	Servo _Track1_Servo;
	Servo _Track2_Servo;

  	void BeaconControl();
  	void Servo_Update();

};


#endif
